<template>
  <div id="talks" ref="talks">

    <v-sheet v-if="person" class="header" color="white" elevation="2" height="50" outlined shaped width="70%">
      <h3>rozmowa z {{ person.nick }}</h3>
    </v-sheet>
    <v-sheet v-if="!person" color="white" elevation="2" height="100" outlined shaped width="106">
      wybierz osobę z listy
    </v-sheet>
    <template>
      <v-card class="mx-auto chats" tile>
        <v-list>
          <v-list-item v-for="(talk, index) in talks" :key="index" :class="{
            chat: true,
            left: talk.nick === $store.state.user.nick,
            right: talk.nick !== $store.state.user.nick
          }">
            <v-list-item-content>
              <!-- {{talk}} -->
              <v-list-item-title class="nick">
                {{ getNick(talk) }}
              </v-list-item-title>
              <v-card class="content">
                <div v-html="talk.content"></div>
                <span>
                  {{
                    new Date(Date.parse(talk.datetime)).toLocaleDateString(
                      "pl-PL"
                    ) +
                    ", " +
                    new Date(talk.datetime).toLocaleTimeString("pl-PL", {
                      weekday: "long",
                    })
                  }}</span>
              </v-card>
            </v-list-item-content>
          </v-list-item>
          <v-list-item class="right input-wrapper">
            <v-card class="content blocked" v-if="person.blocked || person.blocks">
              <!-- Został{{ $store.state.user.sex ? "eś" : "aś" }} zablokowan{{
                $store.state.user.sex === 1 ? "y" : "a"
              }}
            </v-card>
            <v-card class="content blocked" color="error" v-if="person.blocks">
              Zablokowałeś {{ person.nick }}-->
              blokada konta
            </v-card>
            <EmoisComponent v-if="!person.blocked && !person.blocks" />
            <InputComponent v-if="!person.blocked && !person.blocks" @content="(data) => {
              setContent(data);
            }
              " :init="init" />

            <v-card class="content">
              <v-icon v-if="!person.blocked && !person.blocks" @click="sendMessage"
                style="z-index: 1000; cursor: pointer; top: 44px; right: -3px">
                mdi-send
              </v-icon>
            </v-card>
          </v-list-item>
        </v-list>
      </v-card>
    </template>
  </div>
</template>
<script>


export default {
  name: "TalksComponent",

  props: {
    person: {
      type: Object,
      default: { nick: null },
      required: false,
    },

    wave: {
      type: Boolean,
      required: false,
      default: false,
    },
  },

  data() {
    return {
      content: "",

      talks: [],
      photo: null
    };
  },

  computed: {
    init() {
      return this.wave ? ":handwave:" : "";
    },
  },

  beforeCreate() { },

  mounted() {


    this.setFriend();
    this.$bus.$on(this.person.nick, (data) => {
      const message = {
        datetime: new Date(data.datetime),
        nick: this.$store.state.user.nick,
        content: data.content,
      };
      this.talks.push(message);
    });
    this.$bus.$on('scroll-messages', () => {
      this.scrollToBottom();
    })

    this.$refs.talks.addEventListener('scroll', ({target}) => {

      if (target.scrollHeight - target.scrollTop === target.clientHeight) {
        this.$emit('scrolled-to-bottom')
        console.log('Element przewinięty do samego dołu');
      } else {
        this.$emit('un-scrolled')
      }
    })
  },

  methods: {
    setContent(content) {
      this.content = content;
    },

    sendMessage() {
      const message = {
        datetime: new Date().toISOString().slice(0, 19).replace('T', ' '),
        nick: this.person.nick,
        content: this.content,
      };
      this.talks.push(message);
      this.$store.state.ws.send(
        JSON.stringify({
          message: {
            [this.person.nick]: JSON.stringify(message),
            from: this.$store.state.user.uuid,
          },
        })
      );
      this.setContent("");
      this.$bus.$emit("clear-input");
    },

    setFriend() {
      this.$axios
        .get(this.$config.serverUrl + "/user/messages", {
          params: {
            uuid: this.$store.state.user.uuid,
            friendNick: this.person.nick,
          },
        })
        .then(({ data }) => {
          this.talks = data;
          this.$nextTick(()=>{
        this.scrollToBottom();
      })
        });
    },

    scrollToBottom() {
      if(!this.$refs.talks) return;
      this.$refs.talks.scrollTop = this.$refs.talks.scrollHeight;
    },
    getNick(talk) {
      if (typeof talk.nick === "undefined") {
        return this.$store.state.user.nick;
      }
      return talk.nick === this.person.nick
        ? this.$store.state.user.nick
        : this.person.nick;
    },
  },

  watch: {
    'person.nick': function () {
      this.setFriend();
    },
  },
};
</script>
<style scoped lang="scss">
h3 {
  color: rgba(0, 0, 0, 0.7);
}

#talks {
  overflow: scroll;
  height: 90vh;
  width: 57vw;

  .header {
    margin: 10px 0px 0 20px;
    padding: 12px;
  }

  .chats {
    margin-top: 40px;
    width: 100%;
    color: rgba(10, 10, 10, 0.7) !important;

    .chat {
      box-shadow: 8px 8px 32px -16px rgba(66, 68, 90, 1);
      width: 88%;
      padding: 8px;
      margin: 12px 0 !important;
      color: rgba(75, 75, 75, 0.7) !important;

      &.left {
        .nick {
          color: rgba(100, 100, 100, 0.9) !important;
        }

        background: white;
        transform: translateX(0px);
      }

      &.right {
        background: white;
        transform: translateX(46px);

        .nick {
          color: rgba(100, 100, 100, 0.7) !important;
        }
      }

      &>*>div {
        padding: 7px;
      }

      span {
        float: right;
        padding: 10px;
        font-size: 11px;
        color: rgba(10, 10, 10, 0.7);
      }
    }
  }

  .blocked {
    padding: 25px;
  }
}

.theme--light.v-list-item:not(.v-list-item--active):not(.v-list-item--disabled) {
  display: flex;
  justify-content: center;
}
</style>
